#ifdef USE_METAL
float2 GetSingleParaboloidReflectionUV(float3 reflectionVector)
{
	float4 d = float4(0.0,0.0,1.0,0.0);
	float3 finalCoord = reflectionVector;
	finalCoord += d.xyz;
	finalCoord.xy /= finalCoord.z;
	finalCoord.xy = finalCoord.xy * float2(0.5, -0.5) + 0.5;
	return finalCoord.xy;
}

float2 GetParaboloidReflectionBottomUV(float3 reflectionVector)
{
	float4 d = float4(0.0,0.0,-1.0,0.0);
	float3 finalCoord = reflectionVector;
	finalCoord += d.xyz;
	finalCoord.xy /= finalCoord.z;
	finalCoord.xy = finalCoord.xy * float2(0.5, -0.5) + 0.5;
	return finalCoord.xy;
}

float2 GetParaboloidReflectionExtendentDistanceUV(float3 reflectionVector)
{
	float4 d = float4(0.0,0.0,1.5,0.0);
	float3 finalCoord = reflectionVector;
	finalCoord += d.xyz;
	finalCoord.xy /= finalCoord.z;
	finalCoord.xy = finalCoord.xy * float2(0.5, -0.5) + 0.5;
	return finalCoord.xy;
}

#else
highp vec2 GetSingleParaboloidReflectionUV(highp vec3 reflectionVector)
{
	highp vec4 d = vec4(0.0,0.0,1.0,0.0);
	highp vec3 finalCoord = reflectionVector;
	finalCoord += d.xyz;
	finalCoord.xy /= finalCoord.z;
	finalCoord.xy = finalCoord.xy*0.5 + 0.5;
	return finalCoord.xy;
}

highp vec2 GetParaboloidReflectionBottomUV(highp vec3 reflectionVector)
{
	highp vec4 d = vec4(0.0,0.0,-1.0,0.0);
	highp vec3 finalCoord = reflectionVector;
	finalCoord += d.xyz;
	finalCoord.xy /= finalCoord.z;
	finalCoord.xy = finalCoord.xy*0.5 + 0.5;
	return finalCoord.xy;
}

highp vec2 GetParaboloidReflectionExtendentDistanceUV(highp vec3 reflectionVector)
{
	highp vec4 d = vec4(0.0,0.0,1.5,0.0);
	highp vec3 finalCoord = reflectionVector;
	finalCoord += d.xyz;
	finalCoord.xy /= finalCoord.z;
	finalCoord.xy = finalCoord.xy*0.5 + 0.5;
	return finalCoord.xy;
}
#endif
